// -*- MaTX -*-

// sim00007.mm: tmd00007.{h,mm} ΥƥȤΤΥߥ졼
//
//   Originally written by KIYOTA Hiromitsu <1999/01/19>
//   Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
//
// RCS: $Id: sim00007.mm,v 1.3 1999/05/31 03:32:51 kiyota Exp $

// Local options
//#define NOPLOT
//#define MULTIPLOT

// These are required #definitions.
#define TMD00007_USER_H "sim00007.h"
#define TMD00007_USER_MM "sim00007.mm"

// TMD00007_USER_H  #include 롣
#include "tmd00007.h"

Matrix F;

Func void
main()
{
  Matrix TC, XC, UC;
  Matrix link_eqs();
#ifndef NOPLOT
  List names;
  Integer i;
#ifdef MULTIPLOT
  Integer hmultiplot(...) require "hplot.mm";
#endif /* MULTIPLOT */
#endif /* ! NOPLOT */

  init_tmd00007(1); // Υߥ졼
//  init_tmd00007(); // Υߥ졼 (not given)

  F = Optimal(tmd00007(A), tmd00007(B0),
	      diag([1000.0], [1000.0], [100.0], [100.0],
		   [10.0], [10.0], [10.0], [10.0]), // Q
	      diag([1.0], [1.0])); // r
  
  {TC, XC, UC} = Ode45Auto(0.0, 10.0,
#ifndef TMD00007_USER_DIFF
			   [1e-2, -1e-2, -5e-2, 5e-2, 0.0, 0.0, 0.0, 0.0]',
#else /* TMD00007_USER_DIFF */
			   [[1e-2, -1e-2, -5e-2, 5e-2, 0.0, 0.0, 0.0, 0.0],
			    [0.0, 0.0]]', // ưŪν
#endif /* ! TMD00007_USER_DIFF */
			   diff_tmd00007, link_eqs);
  print [[TC][XC][UC]] >> "sim.mat";

#ifndef NOPLOT
  names = {"x1(=y1)", "x2(=y2)", "phi1(=y3)", "phi2(=y4)",
	   "dot_x1", "dot_x2", "dot_phi1", "dot_phi2", 
	   "Ea1(=u1)", "Ea2(=u2)", "-", "-", "-", "-"};

#ifndef MULTIPLOT
   for (i = 1; i <= length(names); ++i)
     {
       if (names(i, String) == "-") { continue; }
       mgplot_grid(i, 1);
       mgplot(i, TC(1,:), [[XC][UC]](i,:), {names(i, String)});
     }
#else /* MULTIPLOT */
  hmultiplot(1, TC, [[XC][UC]], names);
#endif /* ! MULTIPLOT */
  pause;
#endif /* ! NOPLOT */
}


Func Matrix
link_eqs(t, xx)
     Real t;
     Matrix xx;
{
  Matrix uy;
  static Integer running;
  static Matrix u;
  Matrix x, y;

  if (running == 0) // ߥ졼󳫻ϻ
    {
      uy = Z(TMD00007_DIM_ALL_IOS,1);
      u = chop_input_tmd00007(uy);
      running = 1;
    }

  x = chop_state_tmd00007(xx);
  y = output_tmd00007(t, x, u);

  u = F*x; // ֤ΤäƤȤ褦;)

  uy = [[u]
	[y]];
  return uy;
}


#ifdef TMD00007_USER_DIFF
// ߡưŪ
Func Matrix
TMD00007_USER_DIFF(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, z, u, y; // z ϤǤϴ¬ξ֤ʤ

  x = chop_state_tmd00007(xx);
  z = chop_other_state_tmd00007(xx);
  u = chop_input_tmd00007(uu);
  y = output_tmd00007(t, x, u);
  // etc.

  return [1.0, -1.0]'; // ߡΤøʥʥߥ ;-)
}
#endif /* TMD00007_USER_DIFF */
