/* -*- MaTX -*-
 *
 * tmd00007.mm: TMD No. tmd00007 ľ졼ηΩҤΥǥ
 *
 *  Originally written by KIYOTA Hiromitsu <1999/01/19>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00007.mm,v 1.6 1999/06/29 03:51:39 kiyota Exp $
 */

#ifndef _TMD00007_MM
#define _TMD00007_MM

#ifndef TMD_EXTERN
#define TMD_EXTERN extern
#endif /* ! TMD_EXTERN */
#include "tmd00007.h"

// some definitions for local alist
#define _TMD_LALIST {"_tmd00007"}
#define _TMD_LIN_FLAG "linear_flag"

// just for simplicity... B)
#define tmd7(var) tmd00007(var)

Func void
init_tmd00007(linear_flag, params_flag, ...)
     Integer linear_flag, params_flag;
{
#ifndef TMD00007_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00007_DISABLE_HALIST */
  Real Delta1, Delta2, Itilde1, Itilde2, Ihat1, Ihat2;

  switch (nargs)
    {
    case 2:
      break;
    case 0:
      linear_flag = 1; // ǥե: ǥ
    case 1:
      params_flag = 0; // ǥե: ѥ᡼̤
      break;
    default:
      error("init_tmd00007(): Incorrect number of arguments. (nargs=%d)\n", nargs);
      break;
    }

  // ()Υե饰
#ifndef TMD00007_DISABLE_HALIST
  if (halist({_TMD_LALIST, "exists"}) == {})  // if not exist
    {
      halist({_TMD_LALIST, "clear"});  // new alist
    }
  halist(_TMD_LALIST, {{_TMD_LIN_FLAG, linear_flag}});
#else /* TMD00007_DISABLE_HALIST */
  tmd00007_flag = linear_flag;
#endif /* ! TMD00007_DISABLE_HALIST */

  if (params_flag == 0)
    {
      tmd7(M1) = tmd7(M2) = 0.46; /* kg */	// 12˼
      tmd7(mu1) = tmd7(mu2) = 1.8; /* kg/s */	// 12໤
      tmd7(m1) = tmd7(m2) = 0.215; /* kg */	// 12μ
      tmd7(I1) = tmd7(I2) = 0.0409; /* kgm^2 */	// 12νſޤδ⡼
      tmd7(l1) = tmd7(l2) = 0.146; /* m */	// 12νſƼޤǤεΥ
      tmd7(n1) = tmd7(n2) = 0.336; /* m */	// 12νſФͤγƷޤǤεΥ
      tmd7(k) = 1.11; /* kgw/m */		// ФͤΤФ
      tmd7(J) = 3.27e-6; /* kgwms^w */		// ⡼εŪʡ
      tmd7(KT) = 0.0061; /* kgwm/A */		// ⡼Υȥ륯
      tmd7(KE) = 0.0605; /* Vs/rad */		// ⡼ŵȿѤη
      tmd7(Ra) = 1.26; /* ohm */	        // ⡼ŵ
      tmd7(r) = 0.02; /* m */			// סȾ
      tmd7(c11) = tmd7(c21) = 4.61; /* V/m */	// ΰ֡ŰѴ
      tmd7(c12) = tmd7(c22) = 2.76; /* V/rad */	// γ١ŰѴ
      tmd7(g) = 9.8; /* m/s^2 */		// ϲ®
    }

  Delta1 = (tmd7(I1)*(tmd7(M1) + tmd7(m1)) + tmd7(m1)*tmd7(M1)*tmd7(l1)^2
	    + tmd7(J)/tmd7(r)^2*(tmd7(I1) + tmd7(m1)*tmd7(l1)^2));
  Delta2 = (tmd7(I2)*(tmd7(M2) + tmd7(m2)) + tmd7(m2)*tmd7(M2)*tmd7(l2)^2
	    + tmd7(J)/tmd7(r)^2*(tmd7(I2) + tmd7(m2)*tmd7(l2)^2));
  Itilde1 = tmd7(I1) - tmd7(m1)*tmd7(n1)*tmd7(l1);
  Itilde2 = tmd7(I2) - tmd7(m2)*tmd7(n2)*tmd7(l2);
  Ihat1 = ((tmd7(l1) + tmd7(n1))*(tmd7(M1) + tmd7(J)/tmd7(r)^2)
	   + tmd7(n1)*tmd7(m1));
  Ihat2 = ((tmd7(l2) + tmd7(n2))*(tmd7(M2) + tmd7(J)/tmd7(r)^2)
	   + tmd7(n2)*tmd7(m2));

  tmd7(A1) =
    [[-tmd7(k)*Itilde1/Delta1, tmd7(k)*Itilde1/Delta1,
      -(tmd7(m1)^2*tmd7(g)*tmd7(l1)^2 + tmd7(k)*Itilde1*(tmd7(l1) + tmd7(n1)))/Delta1,
      tmd7(k)*Itilde1*(tmd7(l2) + tmd7(n2))/Delta1]
     [tmd7(k)*Itilde2/Delta2, -tmd7(k)*Itilde2/Delta2,
      tmd7(k)*Itilde2*(tmd7(l1) + tmd7(n1))/Delta2,
      -(tmd7(m2)^2*tmd7(g)*tmd7(l2)^2 + tmd7(k)*Itilde2*(tmd7(l2) + tmd7(n2)))/Delta2]
     [-tmd7(k)*Ihat1/Delta1, tmd7(k)*Ihat1/Delta1,
      (tmd7(m1)*tmd7(g)*tmd7(l1)*(tmd7(M1) + tmd7(m1) + tmd7(J)/tmd7(r)^2) - tmd7(k)*Ihat1*(tmd7(l1) + tmd7(n1)))/Delta1,
      tmd7(k)*Ihat1*(tmd7(l2) + tmd7(n2))/Delta1]
     [tmd7(k)*Ihat2/Delta2, -tmd7(k)*Ihat2/Delta2,
      tmd7(k)*Ihat2*(tmd7(l1) + tmd7(n1))/Delta2,
      (tmd7(m2)*tmd7(g)*tmd7(l2)*(tmd7(M2) + tmd7(m2) + tmd7(J)/tmd7(r)^2) - tmd7(k)*Ihat2*(tmd7(l2) + tmd7(n2)))/Delta2]];
  tmd7(A2) =
    [[-(tmd7(I1) + tmd7(m1)*tmd7(l1)^2)/Delta1*(tmd7(mu1) + tmd7(KT)*tmd7(KE)/(tmd7(r)^2*tmd7(Ra))), 0.0, 0.0, 0.0]
     [0.0, -(tmd7(I2) + tmd7(m2)*tmd7(l2)^2)/Delta2*(tmd7(mu2) + tmd7(KT)*tmd7(KE)/(tmd7(r)^2*tmd7(Ra))), 0.0, 0.0]
     [tmd7(m1)*tmd7(l1)/Delta1*(tmd7(mu1) + tmd7(KT)*tmd7(KE)/(tmd7(r)^2*tmd7(Ra))), 0.0, 0.0, 0.0]
     [0.0, tmd7(m2)*tmd7(l2)/Delta2*(tmd7(mu2) + tmd7(KT)*tmd7(KE)/(tmd7(r)^2*tmd7(Ra))), 0.0, 0.0]];
  tmd7(A) = [[    Z(4),     I(4)]
	     [tmd7(A1), tmd7(A2)]];
  tmd7(B) =
    [[tmd7(KT)*(tmd7(I1) + tmd7(m1)*tmd7(l1)^2)/(tmd7(r)*tmd7(Ra)*Delta1), 0.0]
     [0.0, tmd7(KT)*(tmd7(I2) + tmd7(m2)*tmd7(l2)^2)/(tmd7(r)*tmd7(Ra)*Delta2)]
     [-tmd7(m1)*tmd7(l1)*tmd7(KT)/(tmd7(r)*tmd7(Ra)*Delta1), 0.0]
     [0.0, -tmd7(m2)*tmd7(l2)*tmd7(KT)/(tmd7(r)*tmd7(Ra)*Delta2)]];
  tmd7(B0) = [[Z(4,2)]
	      [tmd7(B)]];
  tmd7(C) =
    [[tmd7(c11),       0.0,       0.0,       0.0, 0.0, 0.0, 0.0, 0.0]
     [      0.0, tmd7(c21),       0.0,       0.0, 0.0, 0.0, 0.0, 0.0]
     [      0.0,       0.0, tmd7(c12),       0.0, 0.0, 0.0, 0.0, 0.0]
     [      0.0,       0.0,       0.0, tmd7(c22), 0.0, 0.0, 0.0, 0.0]];
}


Func Matrix
diff_tmd00007(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix dxx;
#ifndef TMD00007_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00007_DISABLE_HALIST */
  Matrix dx, x, u;
#ifdef TMD00007_USER_DIFF
  Matrix TMD00007_USER_DIFF();
#endif /* TMD00007_USER_DIFF */

  x = chop_state_tmd00007(xx);
  u = chop_input_tmd00007(uu);

#ifndef TMD00007_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_LIN_FLAG}) == {0}) // ǥ
#else /* TMD00007_DISABLE_HALIST */
  if (tmd00007_flag == 0) // ǥ
#endif /* ! TMD00007_DISABLE_HALIST */
    {
      // not given.
      dx = tmd7(A)*x + tmd7(B0)*u;
    }
  else // ǥ
    {
      dx = tmd7(A)*x + tmd7(B0)*u;
    }

  dxx = [[dx]
#ifdef TMD00007_USER_DIFF
	 [TMD00007_USER_DIFF(t, xx, uu)]
#endif /* TMD00007_USER_DIFF */
	 ];
  return dxx;
}


Func Matrix
output_tmd00007(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, u, y;

  x = chop_state_tmd00007(xx);
  u = chop_input_tmd00007(uu);

  y = tmd7(C)*x;

  return y;
}

#undef tmd7
#undef _TMD_LALIST
#undef _TMD_LIN_FLAG

#endif /* !_TMD00007_MM */
